<p align="center">
	<img alt="Veloren logo on a screenshot" src="https://i.redd.it/balynnef4x531.png">
</p>

[![pipeline status](https://gitlab.com/veloren/veloren/badges/master/pipeline.svg)](https://gitlab.com/veloren/veloren/commits/master)
[![coverage report](https://gitlab.com/veloren/veloren/badges/master/coverage.svg)](https://gitlab.com/veloren/veloren/commits/master)
[![license](https://img.shields.io/github/license/veloren/veloren.svg)](https://gitlab.com/veloren/veloren/blob/master/LICENSE)
[![discord](https://img.shields.io/discord/449602562165833758.svg)](https://discord.gg/WEXSY9h)
[![lines of code](https://tokei.rs/b1/gitlab/veloren/veloren)](https://tokei.rs/b1/gitlab/veloren/veloren)

## Welcome To Veloren!

Veloren is a multiplayer voxel RPG written in Rust. Veloren takes inspiration from games such as Cube World, Minecraft and Dwarf Fortress. The game is currently under heavy development, but is playable.

## Development

Currently the communication of contributors happens mainly on our [official Discord server](https://discord.gg/kjwJwjK). You can join it to keep up with the development, talk to us or contribute something yourself. Anyone who shows genuine effort to help is welcome in our team. You don't have to know how to program to contribute!

## Useful Links

[The Book](https://book.veloren.net) - A collection of all important information relating to Veloren. It includes information on how to compile Veloren and how to contribute.

[Future Plans](https://gitlab.com/veloren/veloren/milestones) - Go here for information about Veloren's development roadmap and what we're currently working on.

#### Official social media and websites

- [Website](https://veloren.net)
- [Discord Server](https://discord.gg/kjwJwjK)
- [Subreddit](https://www.reddit.com/r/Veloren)

## Get Veloren

Currently we provide 64-bit builds for Linux and Windows which can be downloaded on the official website: 
[https://www.veloren.net](https://veloren.net/welcome)

*Note: Mac and 32-bit systems are supported but you need to [compile the game for them yourself](https://book.veloren.net/compile/index.html).*

Due to rapid developement stable versions become outdated fast and might be **incompatible with the public server**.

If you want to compile Veloren yourself, take a look at the [How to Compile Guide](https://book.veloren.net/compile/index.html) in the book.

### Packaging status

#### Fedora

[COPR repo](https://copr.fedorainfracloud.org/coprs/atim/veloren/): `sudo dnf copr enable atim/veloren -y && sudo dnf install veloren -y`

#### Arch

[AUR Airshipper](https://aur.archlinux.org/packages/airshipper-git): `yay -Sy airshipper-git`

[AUR latest binary release](https://aur.archlinux.org/packages/veloren-bin/): `yay -Sy veloren-bin`

[AUR latest release](https://aur.archlinux.org/packages/veloren/): `yay -Sy veloren`

[AUR latest master](https://aur.archlinux.org/packages/veloren-git): `yay -Sy veloren-git`

## F.A.Q.
### **Q:** How is this game licensed?

**A:** **It's free to play, modify and distribute. Forever.** Since it is a community project, we decided to license it under the **GNU GPL 3.0** license which means it will always stay free and open source.

### **Q:** What platforms are supported?

**A:** Veloren can run on Windows, Linux and Mac OS on all architectures (although x86_64 is our main focus). It's probably possible to compile Veloren on/for BSD, Fuchsia and others as well.

### **Q:** Do you accept donations?

**A:** To keep Veloren a passion project free from financial incentives we will **only accept donations to cover server hosting expenses.** There is no way to donate yet.

## Credit

Many thanks to everyone that has contributed to Veloren's development, provided ideas, crafted art, composed music, hunted bugs, created tools and supported the project.
